// HelloWorldPlus.java
import javax.swing.*;
import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

@SuppressWarnings("serial")
public class HelloWorldPlus extends JComponentBreadboard {

   public HelloWorldPlus() {
      JComponent theCheckBox = new JCheckBox(
          "Use the phrase everyone expects to see.");
      JComponent theLabel = new JLabel();  
      setBreadboard(new Object[][] {
            {theCheckBox},
            {theLabel},
      });
//<<1
      jbConnect(theCheckBox, "useExpectedPhrase");
//>>1
//<<2
      jbConnect(theLabel, "displayedPhrase");
//>>2
   }
   
   private boolean useExpectedPhrase = true;
   public void setUseExpectedPhrase(boolean useExpectedPhrase) {
      this.useExpectedPhrase = useExpectedPhrase;
   }
   public boolean getUseExpectedPhrase() {
      return useExpectedPhrase;
   }
//<<3
   public String getUseExpectedPhraseToolTipText() {
      return getDisplayedPhraseText();
    }
//>>3

   public String getDisplayedPhraseText() {
      if (useExpectedPhrase)
        return "<html><h1>Hello, World !"; 
      else
        return "<html><h1>Goodbye, GridBag !"; 
   }

   public static void main(String[] args) {
       showMessageBreadboard(null, new HelloWorldPlus(), "HelloWorldPlus");
   }

}
