// Deliberately generates every possible breadboard validation error (just to hit
// all these obscure code lines and check that the error messages produced make sense).
import javax.swing.*;
import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

@SuppressWarnings("serial")
public class Test21BadBreadboards extends JComponentBreadboard {

   public Test21BadBreadboards(Object[][] breadboard) {
      super();
      try {
         setBreadboard(breadboard);
      }
      catch (Exception e) {
         e.printStackTrace();
      }
   }
   public static void main(String[] args) {
      JComponent dummy;
      dummy = new Test21BadBreadboards(new Object[][] {
         {},
         {}
      });
      dummy = new Test21BadBreadboards(new Object[][] {
    	         {null, null},
    	         {null}
    	      });
      
      dummy = new Test21BadBreadboards(new Object[][] {
    	         {"String", null},
    	         {null,     null}
    	      });

      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[] {}, null},
    	         {null,     null}
    	      });

      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{}}, null},
    	         {null,     null}
      });
      
      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{new JButton("X")}, {new JButton("Y"), null}}, null},
    	         {null,     null}
    	      });
      
      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{new JButton("X")}, {new JButton("Y")}}, __},
    	         {"",     null}
    	      });

      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{new JButton("X")}, {new JButton("Y")}}, __},
    	         {null,     ""}
    	      });

      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{new JButton("X"), null}, {new JButton("Y"), null}}, __},
    	         {"",     ""},
    	         {"",     ""},
      });
      
      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[] {new JButton("X"), new JButton("Y")}, null},
    	         {null,     null}
      });
      
      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{new JButton("X")}, {new JButton("Y")}}, null},
    	         {null,     null}
      });

      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new JButton[][] {{new JButton("X"), new JButton("Y")}}, null},
    	         {"",     null}
    	      });

      dummy = new Test21BadBreadboards(new Object[][] {
    	         {new Object[][] {{"XXX", new JButton("Y")}}, __},
    	         {"",     ""}
    	      });

      JButton b = new JButton();

      dummy = new Test21BadBreadboards(new Object[][] {
    	         { b, null},
    	         {null, b}
    	      });
      
      
      
      if (dummy==null) dummy = null;
   }

}
