


import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;


import java.util.*;
import java.awt.*;
import java.awt.event.*;

@SuppressWarnings("serial")
public class Test99TestUsedWithEarlierVersion extends JComponentBreadboard {

// declare and create each JComponent placed on the form:
   JButton button1 = new JButton("Increment"); 
   JButton button2 = new JButton("Decrement");
   private String[] cbItems = {"1","2","3","4","5","6","7","8","9","10"};
   JComboBox comboBox = new JComboBox(cbItems); 
   JProgressBar progressBar = new JProgressBar(0,100);
   JScrollBar scrollBar = new JScrollBar(JScrollBar.VERTICAL,5,1, 0, 100);
   JSlider slider = new JSlider(0,100,2);
   JSlider slider2 = new JSlider(0,100,2);
   JSpinner spinner = new JSpinner(new SpinnerNumberModel(2,0,2,1));
   JComponent textArea = xyFill(new JTextArea(3,80));
   JTextField textField = new JTextField(10);
   JCheckBox checkBox = new JCheckBox("Check me");
   JFormattedTextField formattedTextField = new JFormattedTextField(new Date());
   JPasswordField passwordField = new JPasswordField(10);
   JRadioButton radioButton0 = new JRadioButton("Radio 0");
   JRadioButton radioButton1 = new JRadioButton("Radio 1");
   JRadioButton radioButton2 = new JRadioButton("Radio 2");
   
   JComponent[] rbGroup = new JRadioButton[3];
  
   
   JToggleButton toggleButton = new JToggleButton("Toggle Me.");
   JLabel label1 = new JLabel("Accumulator:");
   JLabel label2 = new JLabel("ComboBox:");
   JLabel label3 = new JLabel("Spinner:");
   JLabel label4 = new JLabel("Date:");
   JLabel label5 = new JLabel("Password:");
   JLabel label = new JLabel("Password will be echoed here."); 
// these represent the internal state viewed/controlled by the Breadboard
   private double accumulator = 9;
   private String editableText = "This is just some initial text for test purposes. Feel free to edit, add lines, etc.";
   private boolean theBoolean = true;
   private int theRadioSelection = 2;
   private String theDateString = "2006-01-01";
//   public void setRb0(boolean b) {
//       theRadioSelection=0;  
//   }
//   public void setRb1(boolean b) {
//       theRadioSelection=1;  
//   }
//   public void setRb2(boolean b) {
//      theRadioSelection=2;  
//   }
//   public boolean getRb0() {return 0==theRadioSelection;}
//   public boolean getRb1() {return 1==theRadioSelection;}
//   public boolean getRb2() {return 2==theRadioSelection;}

   public boolean getRb(int iRow) {
      return iRow == theRadioSelection;
   }
   public void setRb(int iRow, boolean value) {
      if (value) 
    	  theRadioSelection = iRow;
      else 
    	  theRadioSelection = -1;  // allows deselection
   }
   
   public void setTheDateString(String sDate) {
      theDateString = sDate;
   }
   public String getTheDateString() {
      return theDateString;
   }
   public void setTheBoolean(boolean b) {
      theBoolean = b;
   }
   public boolean getTheBoolean() {
      return theBoolean; 
   }
   public void setEditableText(String s) {
      editableText = s;
   }
   public String getEditableText() {
      return editableText;
   }
   public void setIncrementButton() {
      accumulator++;
   }
   public String getIncrementButtonText() {
      return button1.getText();
   }
   public void setDecrementButton() {
      accumulator--;
   }
   public String getDecrementButtonText() {
     return button2.getText();
   }
// integer set/gets of accumulator (used by scrollbars and the like)
   public void setAccumulatorAsInt(int value) {
      accumulator = (double) value;
   }
   public int getAccumulatorAsInt() {
      return (int) accumulator;
	}
   public int getAccumulatorAsIntValue() {
	   return (int) accumulator;
   }
	public boolean getAccumulatorAsIntEnabled() {
		return theBoolean;
	}
	public boolean getAccumulatorAsIntVisible() {
		return (theRadioSelection==1)?false:true;
	}
 // String set/gets of accumulator (used by JTextField and JComboBox)
   public void setAccumulatorAsString(String s) {

      try {
         double d = Double.valueOf(s).doubleValue();
         accumulator = d;
      }
      catch (NumberFormatException e) {
         JOptionPane.showMessageDialog(null,"Invalid number: " + s);
      }
   }
   public String getAccumulatorAsString() {
      return String.valueOf((int) accumulator);
	}
	public String[] getAccumulatorAsStringItems() {
		if (cbItems.length < (int) accumulator + 1) {
			cbItems = new String[1 + (int) accumulator];
			for (int i = 0; i < cbItems.length; i++) {
				cbItems[i] = Integer.toString(i);
			}
		}
		return cbItems;
	}
	
   public int getRadioSelection() {
     return theRadioSelection;
   }
    public void setRadioSelection(int theSelection) {
      theRadioSelection = theSelection;
    }
    public String getLabelText() {
    	return getEditableText();
    }
    public String getLabel7Text() {
    	String result = "";
    	for (int i =0; i < accumulator; i++) {
    	  result = result + " ";
    	}
    	result = result + "______";
    	return result;
    }
    public String getLabel8Text() {
    	String result = "";
    	for (int i =0; i < accumulator; i++) {
    	  result = result + " ";
    	}
    	result = result + editableText.substring(
    			Math.min(editableText.length(),(int) accumulator), Math.min(editableText.length(),(int) accumulator + 6));
    	return result;
    }

    JTextField[][] tA = new JTextField[5][4];
    JScrollBar arrayBar = new JScrollBar(JScrollBar.HORIZONTAL,5,1, 0, 95);
    int col0 = 0;  // origin of data array display (linked to arrayBar position)
    int dataArray[][] = new int[5][100];

    public int getArrayBar() { return col0; }
    public void setArrayBar(int iCol0) {col0 = iCol0;}
    public int getArrayBarBlockIncrement() { return tA[0].length-1; }
    public String getTA(int iRow, int iCol) {
       return Integer.toString(dataArray[iRow][col0 + iCol]);
    }

    public void setTA(int iRow, int iCol, String value) {
       dataArray[iRow][col0 + iCol] = Integer.parseInt(value);
    }

    public String getTAInvalidDataMessage(int iRow, int iCol, String sInput) {
       String result = null;
       if (!sInput.trim().matches("[+-]*[0-9]+"))
          result = "Invalid integer, " + sInput + ", at row " + iRow + " and col " + (col0 + iCol);
       return result;
    }
    
   Test99TestUsedWithEarlierVersion() {
      super();
      rbGroup[0] = radioButton0;
      rbGroup[1] = radioButton1;
      rbGroup[2] = radioButton2;
      
// the standard Swing idiom assures only one radiobutton gets selected
// independently of JComponentBreadboard:
//      ButtonGroup buttonGroup = new ButtonGroup();
//      buttonGroup.add(radioButton0);   
//      buttonGroup.add(radioButton1); 
      //      buttonGroup.add(radioButton2);
      JComponent scrollPane = textArea;
//      JComponent scrollPane = fillBoth(new JScrollPane(textArea));
      JLabel label7 = new JLabel("                _____                ");
      label7.setFont(new Font("Monospaced",Font.BOLD,12));
      label.setFont(new Font("Monospaced",Font.PLAIN,12));
      JLabel label8 = new JLabel("");
      label8.setFont(new Font("Monospaced",Font.PLAIN,12));
//      label7.setBorder(BorderFactory.createEmptyBorder(0,0,0,0));       
//      label.setBorder(BorderFactory.createEmptyBorder(0,0,0,0));       
//      label7.setPreferredSize(new Dimension(0,1));
//      label7.setAlignmentY(0);   
//      label.setAlignmentY(1);

      class SelectWhenFocusGained extends FocusAdapter {
         public void focusGained(FocusEvent e) {
            ((JTextField) e.getComponent()).selectAll();
         }
      }
      
     for (int i = 0; i < tA.length; i++) {
        for (int j=0; j < tA[i].length; j++) {
           tA[i][j] = (JTextField) xyFill(false, false, new JTextField(10));
           tA[i][j].addFocusListener(new SelectWhenFocusGained());
        }
     }

     JComponent shim = new JLabel("     ");
     Object[][] breadboard = {
      {NOSCALE,  NOSCALE,NOSCALE,    NOSCALE,             NOSCALE,                NOSCALE,          BISCALE    },
      {NOSCALE,  shim, label1,       textField,           textField,           null,          xAlign(0,scrollBar)},
      {NOSCALE,  null, button1,      button2,             button2,             null,          scrollBar},
      {NOSCALE,  null, slider,       slider,              slider,              slider,        scrollBar},
      {NOSCALE,  null, slider2,      slider2,             slider2,             slider2,       scrollBar},
      {NOSCALE,  null, progressBar,  progressBar,         progressBar,         progressBar,   scrollBar},
      {NOSCALE,  null, progressBar,  progressBar,         progressBar,         progressBar,   scrollBar},
      {NOSCALE,  null, label2,       comboBox,            comboBox,            null,          null},
      {NOSCALE,  null, label3,       spinner,             spinner,             null,          null},
      {NOSCALE,  null, scrollPane,   scrollPane,          scrollPane,          scrollPane,    scrollPane},
      {NOSCALE,  null, scrollPane,   scrollPane,          scrollPane,          scrollPane,    scrollPane},
      {NOSCALE,  null, scrollPane,   scrollPane,          scrollPane,          scrollPane,    scrollPane},
      {NOSCALE,  null, scrollPane,   scrollPane,          scrollPane,          scrollPane,    scrollPane},
      {NOSCALE,  null, tA,           tA,                  tA,                  tA,            null        },
      {NOSCALE,  null, tA,           tA,                  tA,                  tA,            null        },
      {NOSCALE,  null, tA,           tA,                  tA,                  tA,            null        },
      {NOSCALE,  null, tA,           tA,                  tA,                  tA,            null        },
      {NOSCALE,  null, tA,           tA,                  tA,                  tA,            null        },
      {NOSCALE,  null, arrayBar,     arrayBar,            arrayBar,            arrayBar,      null},
      {NOSCALE,  null, checkBox,     toggleButton,        null,                null,          null},
      {NOSCALE,  null, rbGroup,      rbGroup,             rbGroup,        null,          null},
      {NOSCALE,  null, label4,       formattedTextField,  formattedTextField,  null,          null},
      {NOSCALE,  null, label5,       passwordField,       passwordField,       null,          null},
//      {jpan,        jpan,                 jpan,                jpan,          jpan},
      {NOSCALE,  null, label7,       label7,               label7,     label7,         label7},
      {NOSCALE,  null, label,       label,               label,       label,         label},
      {NOSCALE,  null, label8,       label8,               label8,     label8,         label8},
      };
      setBreadboard(breadboard);
      jbConnect(button1, "incrementButton");
      jbConnect(button2,  "decrementButton");
      jbConnect(textField, "accumulatorAsString");     // String setters/getter
      jbConnect(comboBox, "accumulatorAsString");
      jbConnect(progressBar, "accumulatorAsInt");      // int setters/getters
      jbConnect(scrollBar, "accumulatorAsInt");
      jbConnect(slider, "accumulatorAsInt");
      jbConnect(textArea, "editableText");
      jbConnect(passwordField, "editableText");
      jbConnect(label, "label");
      jbConnect(formattedTextField, "theDateString");
      jbConnect(spinner, "radioSelection");
//      jbConnect(radioButton0, "rb0");
//      jbConnect(radioButton1, "rb1");
//      jbConnect(radioButton2, "rb2");
      jbConnect(rbGroup, "rb");      
      jbConnect(checkBox, "theBoolean");
      jbConnect(toggleButton, "theBoolean");
      jbConnect(label7, "label7");
      jbConnect(label8, "label8");

      jbConnect(tA, "tA");
      jbConnect(arrayBar, "arrayBar");
      
      
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test99TestUsedWithEarlierVersion(),"Test99TestUsedWithEarlierVersion()");
   }
}
